var pref_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var gpreferences = pref_service.getBranch("extensions.grooveshredder");

var grooveshredder = {
  onLoad: function() {
    // initialization code
    this.strings = document.getElementById("grooveshredder-strings");
    grooveRequestObserver.register();
    // to be or not to be
    if(gpreferences.prefHasUserValue("enabled")){
    	if(gpreferences.getBoolPref("enabled")){
    		grooveshredder.setEnabled();
    	} else {
    		grooveshredder.setDisabled();
    	}
    } else {
    	grooveshredder.setEnabled();
    }
  },
  onToolbarButtonCommand: function(e) {
    // If on turn off, if off turn on!
    if(this.initialized){
    	this.setDisabled();
		alert("Grooveshredder is now disabled.");
	} else {
		this.setEnabled();
		alert("Grooveshredder is now enabled.");
	}
  },
  setEnabled: function() {
  		var btn = document.getElementById("grooveshredder-toolbar-button");
		this.initialized = true;
		gpreferences.setBoolPref("enabled", true);
		grooveRequestObserver.register();
		btn.setAttribute("class","grooveshredder-tbutton-on toolbarbutton-1 chromeclass-toolbar-additional");  
  },
  setDisabled: function() {
  		var btn = document.getElementById("grooveshredder-toolbar-button");
		this.initialized = false;
		gpreferences.setBoolPref("enabled", false);
		grooveRequestObserver.unregister();
		btn.setAttribute("class","grooveshredder-tbutton-off toolbarbutton-1 chromeclass-toolbar-additional");
  }
};

var grooveRequestObserver =
{
  observe: function(subject, topic, data)
  {
    var channel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
    var re = /http:\/\/(.*).grooveshark.com\/stream.php/;
    if(channel.URI.spec.match(re)){
    	// Extract URL and POSTDATA, perform separate request
    	this.streamURL = channel.URI.spec;
    	this.postdata = getPostData(subject);
    	if(typeof window.content.multipreven == 'undefined' || window.content.multipreven == 0){
    		window.content.multipreven = 1;
			grooveDownloader.execute(this.streamURL, this.postdata, subject);
		} else {
			window.content.multipreven++;
			if(window.content.multipreven == 4){
				window.content.multipreven = 0;
			}
		}
    }
  },

  get observerService() {
    return Components.classes["@mozilla.org/observer-service;1"]
                     .getService(Components.interfaces.nsIObserverService);
  },

  register: function()
  {
    this.observerService.addObserver(this, "http-on-modify-request", false);
  },

  unregister: function()
  {
    this.observerService.removeObserver(this, "http-on-modify-request");
  }
};

var grooveDownloader = {
	init: function(url, data, origRequest) {
		this.ios = Components.classes['@mozilla.org/network/io-service;1']
						.getService(Components.interfaces.nsIIOService);
		this.persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
                        .createInstance(Components.interfaces.nsIWebBrowserPersist);
		this.xfer = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);
		
		this.url = url;
		this.data = data;
		this.origRequest = origRequest;
	},
	checkValid: function(data)
	{
		return true;
	},
	getFileName: function()
	{
		var songDetails = content.document.getElementById("playerDetails_nowPlaying").innerHTML;
		var name_regex = /class="song.*" title="(.*)"/;
		var from_regex = /class="artist.*" title="(.*)"/;
		var album_regex = /class="album.*" title="(.*)"/;
		var song_name = songDetails.match(name_regex)[1].replace("&amp;", "&");
		var song_artist = songDetails.match(from_regex)[1].replace("&amp;", "&");
		var song_album = songDetails.match(album_regex)[1].replace("&amp;", "&");
		var file_pref = gpreferences.getCharPref(".filename");
		this.song_file = file_pref.replace("%artist%", song_artist)
									.replace("%title%", song_name)
										.replace("%album%", song_album) + ".mp3";
	},
	runFilePicker: function()
	{
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "Save GrooveShredded File As...", nsIFilePicker.modeSave);
		fp.appendFilter("MP3 Files","*.mp3");
		fp.defaultString = this.song_file;
		var res = fp.show();
		if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace){
			this.thefile = fp.file;
			this.obj_URI = this.ios.newURI(this.url, null, null);
			this.file_URI = this.ios.newFileURI(this.thefile);
			return true;
		}
		else return false;
	},
	saveSong: function()
	{
		// Cancel original request
		this.origRequest.cancel(Components.results.NS_BINDING_SUCCEEDED);
		this.xfer.init(this.obj_URI, this.file_URI, "", null, null, null, this.persist);
		this.persist.progressListener = this.xfer; 
		this.persist.saveURI(this.obj_URI, null, null, this.data, "", this.thefile);	
	},
	execute: function(url, data, origRequest)
	{
		this.init(url, data, origRequest);
		this.getFileName();
		if(this.runFilePicker()){
			this.saveSong();
		}
	}
};

function getPostData(subject){
	var dataStream = subject.QueryInterface(Components.interfaces.nsIUploadChannel).uploadStream;
	dataStream.QueryInterface(Ci.nsISeekableStream).seek(Ci.nsISeekableStream.NS_SEEK_SET, 0);
	return dataStream;
}

window.addEventListener("load", function () { grooveshredder.onLoad(); }, false);